/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ContactDevices type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactDevices{}

// ContactDevices struct for ContactDevices
type ContactDevices struct {
	Type *string `json:"type,omitempty"`
	BrandCode *string `json:"brand_code,omitempty"`
	DeviceName *string `json:"device_name,omitempty"`
	DeviceType *string `json:"device_type,omitempty"`
	OsFamilyCode *string `json:"os_family_code,omitempty"`
	OsName *string `json:"os_name,omitempty"`
	BrowserName *string `json:"browser_name,omitempty"`
}

// NewContactDevices instantiates a new ContactDevices object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactDevices() *ContactDevices {
	this := ContactDevices{}
	return &this
}

// NewContactDevicesWithDefaults instantiates a new ContactDevices object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactDevicesWithDefaults() *ContactDevices {
	this := ContactDevices{}
	return &this
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *ContactDevices) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactDevices) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *ContactDevices) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *ContactDevices) SetType(v string) {
	o.Type = &v
}

// GetBrandCode returns the BrandCode field value if set, zero value otherwise.
func (o *ContactDevices) GetBrandCode() string {
	if o == nil || IsNil(o.BrandCode) {
		var ret string
		return ret
	}
	return *o.BrandCode
}

// GetBrandCodeOk returns a tuple with the BrandCode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactDevices) GetBrandCodeOk() (*string, bool) {
	if o == nil || IsNil(o.BrandCode) {
		return nil, false
	}
	return o.BrandCode, true
}

// HasBrandCode returns a boolean if a field has been set.
func (o *ContactDevices) HasBrandCode() bool {
	if o != nil && !IsNil(o.BrandCode) {
		return true
	}

	return false
}

// SetBrandCode gets a reference to the given string and assigns it to the BrandCode field.
func (o *ContactDevices) SetBrandCode(v string) {
	o.BrandCode = &v
}

// GetDeviceName returns the DeviceName field value if set, zero value otherwise.
func (o *ContactDevices) GetDeviceName() string {
	if o == nil || IsNil(o.DeviceName) {
		var ret string
		return ret
	}
	return *o.DeviceName
}

// GetDeviceNameOk returns a tuple with the DeviceName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactDevices) GetDeviceNameOk() (*string, bool) {
	if o == nil || IsNil(o.DeviceName) {
		return nil, false
	}
	return o.DeviceName, true
}

// HasDeviceName returns a boolean if a field has been set.
func (o *ContactDevices) HasDeviceName() bool {
	if o != nil && !IsNil(o.DeviceName) {
		return true
	}

	return false
}

// SetDeviceName gets a reference to the given string and assigns it to the DeviceName field.
func (o *ContactDevices) SetDeviceName(v string) {
	o.DeviceName = &v
}

// GetDeviceType returns the DeviceType field value if set, zero value otherwise.
func (o *ContactDevices) GetDeviceType() string {
	if o == nil || IsNil(o.DeviceType) {
		var ret string
		return ret
	}
	return *o.DeviceType
}

// GetDeviceTypeOk returns a tuple with the DeviceType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactDevices) GetDeviceTypeOk() (*string, bool) {
	if o == nil || IsNil(o.DeviceType) {
		return nil, false
	}
	return o.DeviceType, true
}

// HasDeviceType returns a boolean if a field has been set.
func (o *ContactDevices) HasDeviceType() bool {
	if o != nil && !IsNil(o.DeviceType) {
		return true
	}

	return false
}

// SetDeviceType gets a reference to the given string and assigns it to the DeviceType field.
func (o *ContactDevices) SetDeviceType(v string) {
	o.DeviceType = &v
}

// GetOsFamilyCode returns the OsFamilyCode field value if set, zero value otherwise.
func (o *ContactDevices) GetOsFamilyCode() string {
	if o == nil || IsNil(o.OsFamilyCode) {
		var ret string
		return ret
	}
	return *o.OsFamilyCode
}

// GetOsFamilyCodeOk returns a tuple with the OsFamilyCode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactDevices) GetOsFamilyCodeOk() (*string, bool) {
	if o == nil || IsNil(o.OsFamilyCode) {
		return nil, false
	}
	return o.OsFamilyCode, true
}

// HasOsFamilyCode returns a boolean if a field has been set.
func (o *ContactDevices) HasOsFamilyCode() bool {
	if o != nil && !IsNil(o.OsFamilyCode) {
		return true
	}

	return false
}

// SetOsFamilyCode gets a reference to the given string and assigns it to the OsFamilyCode field.
func (o *ContactDevices) SetOsFamilyCode(v string) {
	o.OsFamilyCode = &v
}

// GetOsName returns the OsName field value if set, zero value otherwise.
func (o *ContactDevices) GetOsName() string {
	if o == nil || IsNil(o.OsName) {
		var ret string
		return ret
	}
	return *o.OsName
}

// GetOsNameOk returns a tuple with the OsName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactDevices) GetOsNameOk() (*string, bool) {
	if o == nil || IsNil(o.OsName) {
		return nil, false
	}
	return o.OsName, true
}

// HasOsName returns a boolean if a field has been set.
func (o *ContactDevices) HasOsName() bool {
	if o != nil && !IsNil(o.OsName) {
		return true
	}

	return false
}

// SetOsName gets a reference to the given string and assigns it to the OsName field.
func (o *ContactDevices) SetOsName(v string) {
	o.OsName = &v
}

// GetBrowserName returns the BrowserName field value if set, zero value otherwise.
func (o *ContactDevices) GetBrowserName() string {
	if o == nil || IsNil(o.BrowserName) {
		var ret string
		return ret
	}
	return *o.BrowserName
}

// GetBrowserNameOk returns a tuple with the BrowserName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactDevices) GetBrowserNameOk() (*string, bool) {
	if o == nil || IsNil(o.BrowserName) {
		return nil, false
	}
	return o.BrowserName, true
}

// HasBrowserName returns a boolean if a field has been set.
func (o *ContactDevices) HasBrowserName() bool {
	if o != nil && !IsNil(o.BrowserName) {
		return true
	}

	return false
}

// SetBrowserName gets a reference to the given string and assigns it to the BrowserName field.
func (o *ContactDevices) SetBrowserName(v string) {
	o.BrowserName = &v
}

func (o ContactDevices) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactDevices) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.BrandCode) {
		toSerialize["brand_code"] = o.BrandCode
	}
	if !IsNil(o.DeviceName) {
		toSerialize["device_name"] = o.DeviceName
	}
	if !IsNil(o.DeviceType) {
		toSerialize["device_type"] = o.DeviceType
	}
	if !IsNil(o.OsFamilyCode) {
		toSerialize["os_family_code"] = o.OsFamilyCode
	}
	if !IsNil(o.OsName) {
		toSerialize["os_name"] = o.OsName
	}
	if !IsNil(o.BrowserName) {
		toSerialize["browser_name"] = o.BrowserName
	}
	return toSerialize, nil
}

type NullableContactDevices struct {
	value *ContactDevices
	isSet bool
}

func (v NullableContactDevices) Get() *ContactDevices {
	return v.value
}

func (v *NullableContactDevices) Set(val *ContactDevices) {
	v.value = val
	v.isSet = true
}

func (v NullableContactDevices) IsSet() bool {
	return v.isSet
}

func (v *NullableContactDevices) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactDevices(val *ContactDevices) *NullableContactDevices {
	return &NullableContactDevices{value: val, isSet: true}
}

func (v NullableContactDevices) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactDevices) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


